unit UQueue;

interface
type

   ukaz = ^zveno;
   zveno = record
      x: integer;
      y: integer;
      next: ukaz;
      end;
   TQueue = class
     private
        FHead: ukaz;
        FTail: ukaz;
     public
     constructor Create;
     destructor Destroy; override;
     function IsEmpty:boolean;
     procedure Push(x,y:integer);
     procedure Pop(var x, y:integer);
     end;

implementation

constructor TQueue.Create;
begin
inherited Create;
FHead:=nil;
FTail:=nil;
end;

function TQueue.IsEmpty;
begin
Result:=FHead=nil;
end;

procedure TQueue.Pop;
var z: ukaz;
begin
if not IsEmpty then
  begin
    z:=FHead;
    x:=z^.x;
    y:=z^.y;
    FHead:=FHead.next;
    dispose(z);
  end;
end;

procedure TQueue.Push;
var z: ukaz;
begin
  new(z);
  z^.x:=x;
  z^.y:=y;
  z^.next:=nil;
  if IsEmpty then FHead:=z
  else FTail.next:=z;
FTail:=z;
end;

destructor TQueue.Destroy;
var x,y,n,x1,y1:integer;
begin
  while not IsEmpty do Pop(x,y);
  inherited Destroy;
end;


end.
